#!/bin/ksh -x
#
# Verifica se foi passado algum parametro
if (($#<4)) ; then
export Run_Date=`date "+%Y%m%d"`$1
else
export Run_Date=${4}${1}
fi

export CFS_Member=${2}
export Fcti=${3}

# VARIAVEIS
export Dir_scr=DIRROOT
export Dir_home=`dirname ${Dir_scr}`
export Dir_datain=`dirname ${Dir_home}`
export ModelDrive=`basename  ${Dir_scr}`
export Dir_wrk=${Dir_datain}/atmos/${ModelDrive}.${CFS_Member}/${Run_Date}
export Dir_ETAwrk=${Dir_datain}/atmos/ETAwrk/${ModelDrive}.${CFS_Member}/${Run_Date}
export Dir_SST_ETAwrk=${Dir_datain}/sst/ETAwrk/${ModelDrive}.${CFS_Member}/${Run_Date}
export Dir_util=${Dir_datain}/util
export Dir_dprep_exe=${Dir_datain}/dprep/exe
export InitBC=6
export IntSST=24
export FInitBC=${ModelDrive}.${CFS_Member}

cp ${Dir_scr}/InputModelInf.txt_${ModelDrive} ${Dir_ETAwrk}/InputModelInf.txt

me=$(whoami)
echo "I am $me."

echo 'remove old files!!!'
rm -fv wbin.*
rm -fv wbin.*


typeset -Z6 Fcti 

datefct=`${Dir_util}/caldate.3.0 ${Run_Date} + ${Fcti}hr 'yyyymmddhh'`

echo '==================================================='
echo 'file in process '${Dir_wrk}'/pgbf'${datefct}'.'${CFS_Member}'.'${Run_Date}'.grb2'
echo '==================================================='

if [ ${Fcti} -eq 000000 ];then

line=$(${Dir_util}/wgrib2 -v ${Dir_wrk}'/pgbf'${datefct}'.'${CFS_Member}'.'${Run_Date}'.grb2' | grep "HGT" | grep "10 mb")
adate=`echo ${line}|cut -d"=" -f2|cut -c1-10`
echo $adate > ${Dir_ETAwrk}/adate.txt
echo $adate $Run_Date

if [ $adate -eq $Run_Date ] ; then
  echo "The cfs date is $adate"
else
  echo "Data for $Run_Date isn't available"
  exit 99 
fi
fi

rm -f  ${Dir_ETAwrk}/${FInitBC}_${Run_Date}.${Fcti}
touch  ${Dir_ETAwrk}/${FInitBC}_${Run_Date}.${Fcti}
echo 'OPEN ' ${Dir_ETAwrk}/${FInitBC}_${Run_Date}.${Fcti} '  FILE'


for vars in HGT UGRD VGRD TMP RH; do
for levs in 100000 97500 95000 92500 90000 85000 80000 75000 70000 65000 \
             60000 55000 50000 45000 40000 35000 30000 25000 20000 15000 \
             10000  7000  5000  3000  2000  1000;do


line=$(${Dir_util}/wgrib2 -ctl_inv ${Dir_wrk}'/pgbf'${datefct}'.'${CFS_Member}'.'${Run_Date}'.grb2' | grep "$vars 100,$levs ")

if [ -z "$line" ]; then
echo 'MISSING DATA :: VAR = '$vars' LEVEL = '$levs
else

tptp=`expr index "$line" :`
tptp=`expr $tptp - 1`
nrec=${line:0:$tptp}


${Dir_util}/wgrib2 -d $nrec ${Dir_wrk}'/pgbf'${datefct}'.'${CFS_Member}'.'${Run_Date}'.grb2' -ncpu 4 -append -bin ${Dir_ETAwrk}/${FInitBC}_${Run_Date}.${Fcti} >> ${Dir_ETAwrk}/log.${Fcti}

fi   # if [ -z "$line" ]

done # for levs 
done # for vars 

# SURFACE VARIABLES

# LAND

line=$(${Dir_util}/wgrib2 -ctl_inv ${Dir_wrk}'/flxf'${datefct}'.'${CFS_Member}'.'${Run_Date}'.grb2' | grep "LAND")

if [ -z "$line" ]; then
echo 'NO DATA FOR LAND'
else

tptp=`expr index "$line" :`
tptp=`expr $tptp - 1`
nrec=${line:0:$tptp}

${Dir_util}/wgrib2 -d $nrec ${Dir_wrk}'/flxf'${datefct}'.'${CFS_Member}'.'${Run_Date}'.grb2' -ncpu 4 -new_grid latlon 0:360:1 -90:181:1 ${Dir_ETAwrk}/append.grb2.${Fcti} >> ${Dir_ETAwrk}/log.${Fcti}
${Dir_util}/wgrib2 -d 1 ${Dir_ETAwrk}/append.grb2.${Fcti}  -append -bin ${Dir_ETAwrk}/${FInitBC}_${Run_Date}.${Fcti} >> ${Dir_ETAwrk}/log.${Fcti}

fi

# PRMSL

line=$(${Dir_util}/wgrib2 -ctl_inv ${Dir_wrk}'/pgbf'${datefct}'.'${CFS_Member}'.'${Run_Date}'.grb2' | grep "PRMSL")

if [ -z "$line" ]; then

echo 'NO DATA FOR PRMSL'
else

tptp=`expr index "$line" :`
tptp=`expr $tptp - 1`
nrec=${line:0:$tptp}

${Dir_util}/wgrib2 -d $nrec ${Dir_wrk}'/pgbf'${datefct}'.'${CFS_Member}'.'${Run_Date}'.grb2' -ncpu 4 -append -bin  ${Dir_ETAwrk}/${FInitBC}_${Run_Date}.${Fcti} >> ${Dir_ETAwrk}/log.${Fcti}

fi

# PRESsfc

line=$(${Dir_util}/wgrib2 -ctl_inv ${Dir_wrk}'/flxf'${datefct}'.'${CFS_Member}'.'${Run_Date}'.grb2' | grep "PRES 1")

if [ -z "$line" ]; then

echo 'NO DATA FOR PRES 1'
else

tptp=`expr index "$line" :`
tptp=`expr $tptp - 1`
nrec=${line:0:$tptp}


${Dir_util}/wgrib2 -d $nrec ${Dir_wrk}'/flxf'${datefct}'.'${CFS_Member}'.'${Run_Date}'.grb2' -ncpu 4 -new_grid latlon 0:360:1 -90:181:1  ${Dir_ETAwrk}/append.grb2.${Fcti} >> ${Dir_ETAwrk}/log.${Fcti}
${Dir_util}/wgrib2 -d 1 ${Dir_ETAwrk}/append.grb2.${Fcti}  -ncpu 4 -append -bin ${Dir_ETAwrk}/${FInitBC}_${Run_Date}.${Fcti} >> ${Dir_ETAwrk}/log.${Fcti}
fi

# HGTsfc

line=$(${Dir_util}/wgrib2 -ctl_inv ${Dir_wrk}'/flxf'${datefct}'.'${CFS_Member}'.'${Run_Date}'.grb2' | grep "HGT 1")

if [ -z "$line" ]; then

echo 'NO DATA FOR HGTsfc'
else

tptp=`expr index "$line" :`
tptp=`expr $tptp - 1`
nrec=${line:0:$tptp}

${Dir_util}/wgrib2 -d $nrec ${Dir_wrk}'/flxf'${datefct}'.'${CFS_Member}'.'${Run_Date}'.grb2' -ncpu 4 -new_grid latlon 0:360:1 -90:181:1  ${Dir_ETAwrk}/append.grb2.${Fcti} >> ${Dir_ETAwrk}/log.${Fcti}
${Dir_util}/wgrib2 -d 1 ${Dir_ETAwrk}/append.grb2.${Fcti}  -ncpu 4 -append -bin ${Dir_ETAwrk}/${FInitBC}_${Run_Date}.${Fcti} >> ${Dir_ETAwrk}/log.${Fcti}

fi

# SOIL VARIABLES

for vars in "TMP 106,0,0.1"\
            "SOILW 106,0,0.1"\
            "TMP 106,0.1,0.4"\
            "SOILW 106,0.1.0.4"\
            "TMP 106,0.4,1"\
            "SOILW 106,0.4,1"\
            "TMP 106,1,2"\
            "SOILW 106,1,2"\
            ; do

line=$(${Dir_util}/wgrib2 -ctl_inv ${Dir_wrk}'/flxf'${datefct}'.'${CFS_Member}'.'${Run_Date}'.grb2' | grep "$vars")

if [ -z "$line" ]; then
echo 'NO DATA FOR VAR = '$vars' LEVEL = '$levs'mb'
else

tptp=`expr index "$line" :`
tptp=`expr $tptp - 1`
nrec=${line:0:$tptp}

${Dir_util}/wgrib2 -d $nrec ${Dir_wrk}'/flxf'${datefct}'.'${CFS_Member}'.'${Run_Date}'.grb2' -ncpu 4 -new_grid latlon 0:360:1 -90:181:1  ${Dir_ETAwrk}/append.grb2.${Fcti} >> ${Dir_ETAwrk}/log.${Fcti}
${Dir_util}/wgrib2 -d 1 ${Dir_ETAwrk}/append.grb2.${Fcti}  -ncpu 4 -append -bin ${Dir_ETAwrk}/${FInitBC}_${Run_Date}.${Fcti} >> ${Dir_ETAwrk}/log.${Fcti}

fi   # if [ -z "$line" ]
done # for vars


echo 'DONE WITH ' ${Dir_ETAwrk}/${FInitBC}_${Run_Date}.${Fcti} '  FILE'

ls -l ${Dir_ETAwrk}/${FInitBC}_${Run_Date}.${Fcti}
${Dir_dprep_exe}/dg${ModelDrive}.exe << endin
${Dir_ETAwrk}/${FInitBC}_${Run_Date}.${Fcti}
${Dir_ETAwrk}
endin
exit
